<?php
defined("CODSTATS") or die();

class DataRow{
    public $Name;
    public $XP;
    public $Level;
    public $Class;

    public function  __construct($name, $xp, $level, $class){
        $this->Name = $name;
        $this->XP = $xp;
        $this->Level = $level;
        $this->Class = $class;
    }
};

interface DataSet{
        public function __construct($path, $config);

        public function get($start=0, $num=15);
        public function getByClass($class, $start=0, $num=15);
        public function getByPlayer($data, $key, $start=0, $num=15);

        public function getCount();
        public function getCountByClass($class);
        public function getCountByPlayer($data);

        public function getReadTime();
        public function getUpdateTime($format = "d-m-Y H:m");
};

class DataSetLoader{
    public static function  load($folder, $module, $config = array()) {
        $path = "DataSets/$folder/$module";
        if(!is_dir($path))
            return NULL;
        
        $parent = "DataSets/${folder}/${folder}DataSet.php";
        if(file_exists($parent))
            require_once($parent);

        
        $className = "${folder}DataSet${module}";
        require_once("$path/${className}.php");
        if(class_exists($className))
            return new $className($path, $config);
        
        return NULL;
    }
};

?>
