<?php
defined("CODSTATS") or die();

function __nvaultDataSetbetaAlias($key){
	return nvaultDataSetbeta::CallBack($key);
}
function __nvaultDataSetbetaAlias2($key){
	return nvaultDataSetbeta::CallBack2($key);
}
function __nvaultDataSetbetaAlias3($key){
	return nvaultDataSetbeta::CallBack3($key);
}

class nvaultDataSetbeta extends nvaultDataSet{
        private $temp;
        private $lastClass = -1;
        
        private $temp2;
        private $lastPlayer = "";

        public function __construct($path, $config){
            parent::__construct($path, $config);
        }
        
        public function get($start=0, $num=15){
            $time = microtime(true);

            $this->nvault->fullLoadEntries();
            $this->nvault->sort();

            $time2 = microtime(true);
            $this->readtime = $time2-$time;

            if($num == -1)
                $num = count($this->nvault->Entries);
            
            $data = &array_slice($this->nvault->Entries, $start, $num);
            $this->nvaultToArray($data);
            return $data;
        }
        public function getByClass($class, $start=0, $num=15){
            if($this->lastClass != $class){
                nvaultDataSetbeta::$filter = "-$class-cod";
                $this->nvault->setKeyFilter("__nvaultDataSetbetaAlias2");
                $this->temp = &$this->get($start, $num);
            }
            return array_slice($this->temp, $start, $num);
        }
        public function getByPlayer($data, $key, $start=0, $num=15){
            if($this->lastPlayer != $data){
                nvaultDataSetbeta::$filter = "/^".str_replace("/", "\/",quotemeta( $data))."-([1-9]{1}|[0-9]{2})-cod$/i";
                $this->nvault->setKeyFilter("__nvaultDataSetbetaAlias3");
                $this->temp2 = &$this->get($start, $num);
            }
            return array_slice($this->temp2, $start, $num);
        }

        public function getCount(){ 
            return $this->nvault->LoadEntriesNum();
        }
        public function getCountByClass($class){
            $this->lastClass = $class;
            nvaultDataSetbeta::$filter = "-$class-cod";
            $this->nvault->setKeyFilter("__nvaultDataSetbetaAlias2");
            
            $this->temp = &$this->get(0, -1);
            return count($this->temp);
        }
        public function getCountByPlayer($data){ 
            $this->lastPlayer = $data;
            nvaultDataSetbeta::$filter = "/^".str_replace("/", "\/",quotemeta( $data))."-([1-9]{1}|[0-9]{2})-cod$/i";
            $this->nvault->setKeyFilter("__nvaultDataSetbetaAlias3");
            $this->temp2 = &$this->get(0, -1);
            return count($this->temp2);
        }

        public function getReadTime(){
            return $this->readtime;
        }

        public static function CallBack($key){
		return strcmp($key, nvaultDataSetbeta::$filter) == 0;
	}
	public static function CallBack2($key){
		return strstr($key, nvaultDataSetbeta::$filter) != "";
	}
	public static function CallBack3($key){
		return preg_match(nvaultDataSetbeta::$filter, $key);
	}

        private function nvaultToArray(&$dataToArray){
            foreach($dataToArray as $key => $data){

                $arraykey = $key;
		$value = $data->Value;
                if($value == "")
                    unset($key);

		$key = str_replace("-cod","",$key);

		for($i=strlen($key)-1;$i>=0;$i--){
			if($key[$i] == '-'){
                            $key = array(substr($key, 0, $i), intVal(substr($key, $i+1, strlen($key)-$i)));
                            break;
                        }
                }
                $value = explode("#", $value);
                $dataToArray[$arraykey] = new DataRow($key[0], $value[0], $value[1], $key[1]);
            }
        }
};
?>