<?php
defined("CODSTATS") or die();

function __nvaultDataSetfinalAlias($key){
	return nvaultDataSetfinal::CallBack($key);
}
function __nvaultDataSetfinalAlias2($key){
	return nvaultDataSetfinal::CallBack2($key);
}
function __nvaultDataSetfinalAlias3($key){
	return nvaultDataSetfinal::CallBack3($key);
}

class nvaultDataSetfinal extends nvaultDataSet{
        private $temp;
        private $lastClass = -1;
        
        private $temp2;
        private $lastPlayer = "";

        public function __construct($path, $config){
            parent::__construct($path, $config);
        }
        
        public function get($start=0, $num=15){
            $time = microtime(true);

            $this->nvault->fullLoadEntries();
            $this->nvault->sort();

            $time2 = microtime(true);
            $this->readtime = $time2-$time;

            if($num == -1)
                $num = count($this->nvault->Entries);
            
            $data = &array_slice($this->nvault->Entries, $start, $num);
            $this->nvaultToArray($data);
            return $data;
        }
        public function getByClass($class, $start=0, $num=15){
            if($this->lastClass != $class){
                nvaultDataSetfinal::$filter = "-".Classes::getName($class)."-";
                $this->nvault->setKeyFilter("__nvaultDataSetfinalAlias2");
                $this->temp = &$this->get($start, $num);
            }
            return array_slice($this->temp, $start, $num);
        }
        public function getByPlayer($data, $key, $start=0, $num=15){
            if($this->lastPlayer != $data){
                nvaultDataSetfinal::$filter = "/^".str_replace("/", "\/",quotemeta( $_GET['user']))."-(.*?)-([1-9]{1}|[0-9]{2})-cod$/i";
                $this->nvault->setKeyFilter("__nvaultDataSetfinalAlias3");
                $this->temp2 = &$this->get($start, $num);
            }
            return array_slice($this->temp2, $start, $num);
        }

        public function getCount(){ 
            return $this->nvault->LoadEntriesNum();
        }
        public function getCountByClass($class){
            $this->lastClass = $class;
            nvaultDataSetfinal::$filter = "-".Classes::getName($class)."-";
            $this->nvault->setKeyFilter("__nvaultDataSetfinalAlias2");
            $this->temp = &$this->get(0, -1);
            return count($this->temp);
        }
        public function getCountByPlayer($data){ 
            $this->lastPlayer = $data;
            nvaultDataSetfinal::$filter = "/^".str_replace("/", "\/",quotemeta( $_GET['user']))."-(.*?)-([1-9]{1}|[0-9]{2})-cod$/i";
            $this->nvault->setKeyFilter("__nvaultDataSetfinalAlias3");
            $this->temp2 = &$this->get(0, -1);
            return count($this->temp2);
        }

        public function getReadTime(){
            return $this->readtime;
        }


        public static function CallBack($key){
		return strcmp($key, nvaultDataSetfinal::$filter) == 0;
	}
	public static function CallBack2($key){
		return strstr($key, nvaultDataSetfinal::$filter) != "";
	}
	public static function CallBack3($key){
		return preg_match(nvaultDataSetfinal::$filter, $key);
	}
        public function ClassToNum($class){
            for($i=1;$i<count(Classes::$names);$i++){
                if(Classes::$names[$i] == $class)
                    return $i;
            }
            return -1;
        }
        private function nvaultToArray(&$dataToArray){
            foreach($dataToArray as $key => $data){

                $arraykey = $key;
		$value = $data->Value;
                if($value == "")
                    unset($key);

		$key = str_replace("-cod","",$key);

		$ile = 0;
		for($i=strlen($key)-1;$i>=0;$i--){
			if($key[$i] == '-'){
                            if($ile){
                                $key = array(substr($key, 0, $i), substr($key, $i+1, $ile-$i-1));
                                break;
                             }else{
                                $ile = $i;
                              }
                        }
		}
		$value = explode("#", $value);

		$value = array_slice($value, 1);


                $key[1] = $this->ClassToNum($key[1]);
                $dataToArray[$arraykey] = new DataRow($key[0], $value[0], $value[1], $key[1]);
            }
        }
};
?>