<?php
defined("CODSTATS") or die();

class Content{

    private $dataSet;

    private $title;
    private $header;
    private $saveField = "";

    public function  __construct() {
        require_once("config.php");

        $this->title = $tytul;
        $this->header = $tytul_strony;
        $this->saveField = $zapispo;

        require_once("DataSets/DataSet.php");
        include("themes/".$styl."/theme.php");
        
        
        $folder = "";
        $module = "";

        switch($save){
            case CodMod::NVAULT:
                $folder = "nvault";
                break;
            
            case CodMod::MYSQL:
                $folder = "mysql";
                break;
            
        }

        switch($version){
            case CodMod::NVAULT_BETA:
                $module = "beta";
                break;
            
            case CodMod::NVAULT_FINAL:
                $module = "final";
                break;
            
            case CodMod::MYSQL_MYSQL:
                $module = "mysql";
                break;
            
            case CodMod::MYSQL_DARK:
                $module = "dark";
                break;
            
        }

        $this->dataSet = DataSetLoader::load(
                $folder, $module,
                compact("host", "user", "password", "sciezka", "plik")
        );
        
        if($this->dataSet === NULL){
            die("<h1>DataSet load failed</h1>");
            return;
        }
    }

    public function getTitle(){
        return $this->title;
    }
    public function getHeader(){
        return $this->header;
    }

    
    public function display($filter, $filter_data = 0){
        Theme::HTML_Begin();
        $pages = 0;
        switch($filter){
            case FILTER_ALL:
                $cnt = $this->dataSet->getCount();
            
		$pages = floor($cnt / NUM_PER_PAGE);
		if($cnt%NUM_PER_PAGE)
			++$pages;

		$page = 1;
		if(isset($_GET['page']) && is_numeric($_GET['page'])){
			$page = min($pages, $_GET['page']);
		}
                
                $data = &$this->dataSet->get(NUM_PER_PAGE*($page-1), NUM_PER_PAGE);
                break;
            case FILTER_TOP:
                $data = &$this->dataSet->get();
                break;
            case FILTER_CLASS:
                $cnt = $this->dataSet->getCountByClass($filter_data);

		$pages = floor($cnt / NUM_PER_PAGE);
		if($cnt%NUM_PER_PAGE)
			++$pages;

		$page = 1;
		if(isset($_GET['page']) && is_numeric($_GET['page'])){
			$page = min($pages, $_GET['page']);
		}

                $data = &$this->dataSet->getByClass($filter_data, NUM_PER_PAGE*($page-1), NUM_PER_PAGE);
                break;
            case FILTER_NAME:
                $data = &$this->dataSet->getByPlayer($filter_data, $this->saveField);
                break;
        }

        if(isset($page))
            $i = NUM_PER_PAGE*($page-1);
        else
            $i = 0;

        if($data == NULL)
            Theme::ZeroRows();
        else {
            Theme::HTML_PreListing();
            foreach($data as $value){
                $key = array($value->Name, $value->Class);
                $params = array($value->XP, $value->Level);
                Theme::HTML_Item(++$i, $key, $params);
            }
            Theme::HTML_PostListing();
        }
        
	
        if(isset($page))
            Theme::HTML_Paginator($page, $pages);

        Theme::HTML_Foot($this->dataSet);
        
    }

};
?>
